
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>hibernate之自定义数据类型 / iVAN</title>

    <meta name="description" content="hibernate之自定义数据类型 简介     Hibernate的强大用过的童鞋肯定会知道的,通过OR映射我们可以很方便的实现数据库操作,Hibernate对我们一些类型的映射都提供了很好的支持,但是显然也有不给力的地方,比如简单的注册,一个人可能有好多邮箱,对于这个问题怎么做呢?有人说简单,可以另外开一张表,恩,很不错,确实可以,可是这样有时候可能小题大作了.也有人说,直接将邮箱拼接成字符串然后在存储,这个想法也很好,但在我们读出来的时候就要再进行一次解析操作,将EMAIL还原,这些都要求我们编程人员自己完成.那么Hiber">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">hibernate之自定义数据类型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1><strong>简介</strong></h1>
<p><strong><br /></strong></p>
<p>    Hibernate的强大用过的童鞋肯定会知道的，通过OR映射我们可以很方便的实现数据库操作，Hibernate对我们一些类型的映射都提供了很好的支持，但是显然也有不给力的地方，比如简单的注册，一个人可能有好多邮箱，对于这个问题怎么做呢？有人说简单，可以另外开一张表，恩，很不错，确实可以，可是这样有时候可能小题大作了。也有人说，直接将邮箱拼接成字符串然后在存储，这个想法也很好，但在我们读出来的时候就要再进行一次解析操作，将EMAIL还原，这些都要求我们编程人员自己完成。那么Hibernate有没有提供什么好的支持呢？回答是肯定的，Hibernate给我们提供了一个UserType接口，通过UserType我们可以对一些常见的类型进行封转，转变成具有个性的类型。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjgxNzI0MDM1MjU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjgxNzI1MTg3MTM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjgxNzI2MDM2NjY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p><strong>实现UserType的源码：</strong></p>
<pre><code>package com.zhushuai.hibernate;
import java.io.Serializable;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Types;
import java.util.ArrayList;
import java.util.List;
import org.hibernate.Hibernate;
import org.hibernate.HibernateException;
import org.hibernate.usertype.UserType;
public class EmailType implements UserType{
	private static final char Spliter=';';
	/**
	 * 自定义类型的完全复制方法,构造返回对象
	 *    1. 当nullSafeGet方法调用之后，我们获得了自定义数据对象，在向用户返回自定义数据之前
	 * deepCopy方法被调用，它将根据自定义数据对象构造一个完全拷贝，把拷贝返还给客户使用。
	 *    2.此时我们就得到了自定义数据对象的两个版本
	 *     原始版本由hibernate维护，用作脏数据检查依据，复制版本由用户使用，hibernate将在
	 * 脏数据检查过程中比较这两个版本的数据。
	 *
	 *
	 */
	@Override
	public Object deepCopy(Object value) throws HibernateException {
		List source=(List)value;
		List target=new ArrayList();
		target.addAll(source);
		return target;
	}

	/**
	 * 自定义数据类型比对方法
	 * 用作脏数据检查，X,Y为两个副本
	 */
	@Override
	public boolean equals(Object x, Object y) throws HibernateException {
		if (x==y) {
			return true;
		}
		if(x!=null&amp;&amp;y!=null){
			List xList=(List)x;
			List ylList=(List)y;
			if (xList.size()!=ylList.size()) {
				return false;
			}
			for(int i=0;i&lt;xList.size();i++){
				String s1=(String)xList.get(i);
				String s2=(String)ylList.get(i);
				if (!s1.equals(s2)) {
					return false;
				}
			}
			return true;
		}
		return false;
	}
	/**
	 * 返回给定类型的hashCode
	 */
	@Override
	public int hashCode(Object value) throws HibernateException {
		return value.hashCode();
	}
	/**
	 * 表示本类型实例是否可变
	 */
	@Override
	public boolean isMutable() {
		// TODO Auto-generated method stub
		return false;
	}

	/**
	 * 读取数据转换为自定义类型返回
	 * names包含了自定义类型的映射字段名称
	 */
	@SuppressWarnings("deprecation")
	@Override
	public Object nullSafeGet(ResultSet rs, String[] names, Object owner)
	throws HibernateException, SQLException {
		//取得字段名称并查询
		 String mail_str=(String)Hibernate.STRING.nullSafeGet(rs,names[0]);
	        List temp=new ArrayList&lt;String&gt;();
	        if(mail_str==null)
	        {
	            return null;
	        }
	        else
	        {
	            String[] strs=mail_str.split(";");
	            for(int i=0;i&lt;strs.length;i++)
	            {
	                temp.add(strs[i]);
	            }
	            return temp;
	        }
	}
	/**
	 * 数据保存时被调用
	 */
	@Override
	public void nullSafeSet(PreparedStatement ps, Object value, int index)
	throws HibernateException, SQLException {
		if(value!=null){
			String str=combain((List)value);
			//保存数据
			Hibernate.STRING.nullSafeSet(ps, str,index);
		}else {
			//空值就直接保存了
			Hibernate.STRING.nullSafeSet(ps,value.toString(),index);
		}
	}
	private String combain(List list){
		StringBuffer sb=new StringBuffer();
		for(int i=0;i&lt;list.size()-1;i++){
			sb.append(list.get(i)).append(Spliter);
		}
		sb.append(list.get(list.size()-1));
		return sb.toString();
	}
	/**
	 * 修改类型对应的java类型
	 * 我们这边使用LIST类型
	 */
	@Override
	public Class returnedClass() {
		return List.class;
	}
	/**
	 * 修改类型对应的SQL类型
	 * 使用VARCHAR
	 */
	@Override
	public int[] sqlTypes() {
		return new int[]{Types.VARCHAR};
	}
	@Override
	public Object replace(Object arg0, Object arg1, Object arg2)
	throws HibernateException {
		return null;
	}
	/**
	 * 不知干嘛用的
	 */
	@Override
	public Object assemble(Serializable arg0, Object arg1)
	throws HibernateException {
		return null;
	}
	@Override
	public Serializable disassemble(Object arg0) throws HibernateException {
		return null;
	}
}<b>
</b></code></pre>
<p><strong>Student实体类：</strong></p>
<pre><code>package com.zhushuai.hibernate;
import java.util.HashMap;
import java.util.List;
public class Student {
	String id;
	String name;
	int age;
	String birthday;
	List emails;
	public String getId() {
		return id;
	}
	public void setId(String id) {
		this.id = id;
	}
	public List getEmails() {
		return emails;
	}
	public void setEmails(List emails) {
		this.emails = emails;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getAge() {
		return age;
	}
	public void setAge(int age) {
		this.age = age;
	}
	public String getBirthday() {
		return birthday;
	}
	public void setBirthday(String birthday) {
		this.birthday = birthday;
	}
}
</code></pre>
<p><strong><br /></strong><br />
<strong>student.hbm.xml的配置：</strong></p>
<pre><code>&lt;?xml version="1.0" encoding="UTF-8"?&gt;
&lt;!DOCTYPE hibernate-mapping PUBLIC "-//Hibernate/Hibernate Mapping DTD 3.0//EN" "http://hibernate.sourceforge.net/hibernate-mapping-3.0.dtd" &gt;
&lt;hibernate-mapping&gt;
&lt;class name="com.zhushuai.hibernate.Student"&gt;
&lt;id name="id"&gt;
&lt;generator class="uuid"&gt;&lt;/generator&gt;
&lt;/id&gt;
&lt;property name="name" &gt;&lt;/property&gt;
&lt;property name="age"&gt;&lt;/property&gt;
&lt;property name="birthday"&gt;&lt;/property&gt;
&lt;property name="emails" column="emails" type="com.zhushuai.hibernate.EmailType"/&gt;

&lt;/class&gt;
&lt;/hibernate-mapping&gt;
</code></pre>
<p><strong>client类：</strong></p>
<pre><code>package com.zhushuai.hibernate;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.Configuration;
public class Client {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		//读取hibernate.cfg.xml文件
		Configuration cfg = new Configuration().configure();
		//建立sessionfactory
		SessionFactory sessionfactory = cfg.buildSessionFactory();
		Session  session = null;
		try{
		//开启session
		session = sessionfactory.openSession();
		//开启事务
		session.beginTransaction();
		// 插入数据
		/*
		Student student = new Student();
		 List list=new ArrayList&lt;String&gt;();
		 list.add("shuai.zhu@kodak.com");
		 list.add("454942607@qq.com");
		student.setAge(23);
		student.setBirthday("1990");
		student.setName("zhushuai");
		student.setEmails(list);
		session.save(student);*/
		//获取数据
		String hql = "from Student where name='zhushuai'";
		Query query = session.createQuery(hql);
		List list = query.list();
		Iterator it = list.iterator();
		while(it.hasNext()){
			Student student = (Student) it.next();
			List emailList = student.getEmails();
			for(int i=0;i&lt;emailList.size();i++){
				System.out.println("email  "+i+":"+emailList.get(i));							}
		}
		session.getTransaction().commit();
		}catch(Exception e){
			e.getStackTrace();
			 session.getTransaction().rollback();
		}finally{
			if(session != null){
                if(session.isOpen()){
                    //关闭session
                    session.close();
                }
            }
		}
		// TODO Auto-generated method stub
	}
}<b>
</b></code></pre>
<p><strong><br /></strong><br />
<strong>输出结果：</strong></p>
<p><strong><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MjgxNzMyMzM3OTk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p></strong></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 08:01:36</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java%e6%a0%b8%e5%bf%83%e6%8a%80%e6%9c%af/" title="Java核心技术">Java核心技术</a>, <a href="https://www.iamivan.net/tag/hibernate/" title="Hibernate">Hibernate</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>hibernate之自定义数据类型的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM1dYob.html" rel="bookmark">自定义数据类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				除了使用系统提供的数据类型外,用户还可以根据需要用自定义的数据类型来定义表的列或声明变量. 7.3.1 用Enterprise Manager 创建用户自定义数据类型用Enterprise Manager 创建用户自定义数据类型的方法是:在Enterprise Manager 中选择要创建用户自定义类型的数据库,在数据库对象&quot;User Defined Data Types&quot;上单击右键,从开始菜单中选择&quot;New User Defined Data Type&quot;选项,就会			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/jbEy1nb.html" rel="bookmark">修改自定义数据类型精度</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				数据|数据类型 /*--修改自定义数据类型精度的示例      自定义数据类型一旦被引用,就不能再修改和删除,如果要修改数据的精度,就非常麻烦,下面的示例演示了如何修改      假设要修改的自定义变量名为aa --*/ --1.修改自定义变量类型的名称exec sp_rename 'aa','aa_bak','USERDATATYPE'go --2.新增自定义变量(按新的精度)EXEC sp_addtype N'aa', N'numeric(20,2)', N'not null'go --3.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAaw6KM.html" rel="bookmark">MS SQL基础教程：自定义数据类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				除了使用系统提供的数据类型外,用户还可以根据需要用自定义的数据类型来定义表的列或声明变量. 7.3.1 用Enterprise Manager 创建用户自定义数据类型 用Enterprise Manager 创建用户自定义数据类型的方法是:在Enterprise Manager 中选择要创建用户自定义类型的数据库,在数据库对象&quot;User Defined Data Types&quot;上单击右键,从开始菜单中选择&quot;New User Defined Data Type&quot;选项,就			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQjoqGM.html" rel="bookmark">C&num;怎么解析FLASH自定义数据类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 C#怎么解析FLASHAS3.0自定义数据类型 解决方案			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAVR2Jp.html" rel="bookmark">扩展Hibernate使用自定义数据库连接池的方法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了扩展Hibernate使用自定义数据库连接池的方法.分享给大家供大家参考,具体如下: 在Hibernate的过程中往往碰到这样的问题:我们现成的产品本来已使用自有的数据库连接池,同时使用Hibernate的话在Hibernate配置中也得配置数据库连接信息,这样就需要在两个地方维护数据库连接信息,维护起来感觉相当别扭. 由于我们不是在产品刚开始开发就加入Hibernate的,所以不合适让产品直接使用Hibernate的连接池,只好让Hibernate来使用产品自有的连接池,还好Hi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK3jonb.html" rel="bookmark">hibernate 自定义数据类型 在实现序列化接口后还是抛出不能反序列化的异常</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 异常:org.hibernate.type.SerializationException:couldnotdeserializeatorg.hibernate.util.SerializationHelper.doDeserialize(SerializationHelper.java:262)atorg.hibernate.util.SerializationHelper.deserialize(SerializationHelper.java:306)atorg.hibernate			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk2PVoM.html" rel="bookmark">hibernate中自定义主键生成器</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Hibernate(目前使用的版本是3.2)中提供了多种生成主键的方式. 然而当前的这么多种生成方式未必能满足我们的要求. 比如increment,可以在一个hibernate实例的应用上很方便的时候,但是在集群的时候就不行了. 再如 identity ,sequence ,native 是数据局提供的主键生成方式,往往也不是我们需要,而且在程序跨数据库方面也体现出不足. 还有基于算法的生成方式生成出来的主键基本都是字符串的. 我们现在需要一种生成方式:使用Long作为主键类型,自动增,支持集群			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq7A1Rz.html" rel="bookmark">排序自定义数据类型的arraylist</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 如果有自定义类ManpublicClassMan{privateint_age;publicintAGE{set{_age=value;}get{return_age;}}} 如果想把Man[]数组放到ArrayList中,(1)如何对age进行排序呢?(2)如何取到最大的一个age的下标呢?publicintgetMaxAge(Man[]men){ArrayListmen=newArrayList();intmaxAge=0;for(inti=0;i&lt;men.Length;i++){			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwJDXmp.html" rel="bookmark">hibernate 调用自定义SQLServer函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 我想用HQL来执行SQLServer数据库的函数该怎么去执行?有哪位朋友有个例子,给我揣摩揣摩,小女子不敬感激!本人是新手,分数全用完了,可能分数不够,请不要见怪喔,只求好心朋友帮帮我弄,急赶项目挖.... 解决方案 解决方案二:调用数据库的自定义函数...解决方案三:搭车同问!			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5ooDb.html" rel="bookmark" class="title">jqueryeasyui subgrid的问题</a>
					<div>
						问题描述 jqueryeasyui subgrid的问题 那个UI里的subgrid当我点开那个加号的时候它会列出我下边的子表格我怎么样能获取到父的也就是那个加号是展开还是闭合状态求教高手...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyPLZb.html" rel="bookmark" class="title">关键词选择技巧</a>
					<div>
						技巧 关键词不是仅限于单个的词,还应包括词组和短语. 我们知道,在搜索引擎中检索信息都是通过输入关键词来实现的.因此正如其名所示,关键词的确非常关键.它是整个网站登录过程中最基本,也是最重要的一步,是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRQ78z.html" rel="bookmark" class="title">屏蔽布线系统</a>
					<div>
						屏蔽布线系统源于欧洲,它是在普通非屏蔽布线系统的外面加上金属屏蔽层,利用金属屏蔽层的反射.吸收及趋肤效应实现防止电磁干扰及电磁辐射的功能,屏蔽系统综合利用了双绞线的平衡原理及屏蔽层的屏蔽作用,因而具有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlXKRb.html" rel="bookmark" class="title">RSA算法的实现&lpar;java版&rpar;</a>
					<div>
						package rsa; import java.math.BigInteger; public class RSA { private long p,q,e,d,n; public RSA(){ i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKgmmp.html" rel="bookmark" class="title">PPT制作具有视觉冲击力的击凹字效果</a>
					<div>
						PPT制作具有视觉冲击力的击凹字效果   在PPT中,虽然不能很好的模仿这个特效过程,但模仿这种击凹字效果还是很容易的.下面就跟着Office办公助手的小编一起来试一试使用PPT制作具有视觉冲击力的击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4NNxp.html" rel="bookmark" class="title">WPS 2007快速绘制组织结构图</a>
					<div>
						我们用WPS 2007快速绘制组织结构图: 1.绘制基本图形,在基本图形中缴活文本框. 2.设置图形属性及文本框边距. 3.复制设置好的图形若干份备用. 5.绘制连接线.(www.3lian.com) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQP79wz.html" rel="bookmark" class="title">纳尼亚传奇电影海报中的Logo制作</a>
					<div>
						本教程是从国外教程编译的,供大家交流学习教程,下图大家看到的纳尼亚传奇Logo海报截图是从互联网上找到的,仅供大家参考! 先看效果图: 1.打开Photoshop 软件,执行菜单:&quot;文件&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2yoaBz.html" rel="bookmark" class="title">中华通网络电话在线充值安全吗？</a>
					<div>
						  网络电话网上银行充值安全吗? 当您选择任一银行卡进行网上银行支付时,实际上您已经通过我们的通道直接进入到银行的支付网关了,您输入银行卡资料提交过程全部采用国际通用加密传输,支付系统的安全性由银行全 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkL0nb.html" rel="bookmark" class="title">win7系统电脑设置网卡桥接实现多人玩CS游戏的方法</a>
					<div>
						  win7系统电脑设置网卡桥接实现多人玩CS游戏的方法          具体方法如下: 1.右击网络---属性----单击,更改适配器设置; 2.选中,本地连接与无线网络连接,右击,选择桥接; 3 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKkR65b.html" rel="bookmark" class="title">如何在U盘上锁定自己的文件</a>
					<div>
						  电脑里有重要的资料,不想让别人通过U盘复制自己电脑中的内容.也就是别人在插入U盘后,在可移动的存储设备中不显示.这要如何实现呢? 1.在开始菜单打开&quot;运行&quot;输入&quot;re ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pP8qBAp.html" rel="bookmark" class="title">LVM的创建&comma;修改大小&comma;删除以及彻底卸载的操作步骤</a>
					<div>
						首先解释一下几个关键词 pv: physical volume 物理卷,就是用物理磁盘组成的卷,要在物理磁盘上创建. vg:volume group卷组,就是物理卷组成的卷组合,要在物理卷基础上创建. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24DJZp.html" rel="bookmark" class="title">nginx内部锁的实现</a>
					<div>
						多进程或者多线程的程序,涉及到对共享资源的修改,都需要使用到锁.最常见的情况(也一般是然并卵的情况)是对一个全局变量进行++操作,比如有个全局变量i,如果多个线程同时执行i++,教科书已经提到,是会出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7YRDZM.html" rel="bookmark" class="title">推荐10个2014年最佳的jQuery视频插件&lowbar;jquery</a>
					<div>
						在这篇文章中已经收集了10个最佳的jQuery视频插件,帮助开发人员容易地实现网站播放影片功能.可以显示视频和视频播放列表. 1. Bigvideo.js BigVideo.js 是一个jQuery插 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mvmxwrb.html" rel="bookmark" class="title">《VMware Virtual SAN权威指南（原书第2版）》一2&period;3　网络要求</a>
					<div>
						2.3 网络要求 这一节将从网络角度探讨VSAN的需求和前提条件.VSAN是一种分布式的存储解决方案,因此它对主机之间的通信网络非常倚重,其关键是稳定性和可靠性. 2.3.1 网络接口卡 每台ESXi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE49kJz.html" rel="bookmark" class="title">Hadoop面试中6个常见的问题及答案</a>
					<div>
						你准备好面试了吗?呀,需要 Hadoop 的知识!!?不要慌!这里有一些可能会问到的问题以及你应该给出的答案. Q1.什么是 Hadoop? Hadoop 是一个开源软件框架,用于存储大量数据,并发处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRn4Ab.html" rel="bookmark" class="title">c-&sol;&ast; &num; &ast;&sol;这样的注释行里&num;是什么意思</a>
					<div>
						问题描述 /* # */这样的注释行里#是什么意思 apue里看到的像这样的注释行#define NALLOC 10 /* # client structs to alloc/realloc for  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5oorM.html" rel="bookmark" class="title">看千篇创业文章，都不如自己经历一场</a>
					<div>
						创业前,我看过无数相关的文章,加上我的背景,自认为对创业已做好了充分准备.然而在自己亲身经历之后,发现实际情况大不相同,实际创业的艰难,远大于我们通过文章所获得的想象,无数已知的.未知的命题都需要解, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRO0Xb.html" rel="bookmark" class="title">jquery实现在网页指定区域显示自定义右键菜单效果&lowbar;jquery</a>
					<div>
						本文实例讲述了jquery实现在网页指定区域显示自定义右键菜单效果.分享给大家供大家参考.具体如下: 这是一个jquery实现的网页右键菜单效果,与其它自定义的右键菜单不同之处在于,本菜单只在指定区域 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M94lLRb.html" rel="bookmark" class="title">图像分割之（四）OpenCV的GrabCut函数使用和源码解读</a>
					<div>
						     图像分割之(四)OpenCV的GrabCut函数使用和源码解读                     分类:            图像处理            计算机视觉        ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx04q0M.html" rel="bookmark" class="title">mysql 学习笔记</a>
					<div>
						以前主要使用oracle做数据库,现在换成mysql了,发现不一样的地方还是挺多的,记录一下:  一.centos上的yum install方式安装   完全卸载(可选,如果之前安装了旧版本) a)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLl5NM.html" rel="bookmark" class="title">high utility- High Utility Sequential Patterns</a>
					<div>
						问题描述 High Utility Sequential Patterns High Utility Sequential Patterns学术中文翻译是什么?这种挖掘模式主要解决什么问题?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeolZxM.html" rel="bookmark" class="title">药监局：网售处方药门槛不能改变</a>
					<div>
						本报记者获悉,国家食品药品http://www.aliyun.com/zixun/aggregation/31136.html&quot;&gt;监督管理局针对近期吵得沸沸扬扬的&lt;互联网食品药品 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn84BZb.html" rel="bookmark" class="title">C&num;启动windows服务方法的相关问题分析&lowbar;C&num;教程</a>
					<div>
						C#启动windows服务的方法都是什么呢?C#启动服务类型为Disabled的windows服务会遇到什么样的问题呢?那么本文就向你介绍C#启动windows服务的方法的相关内容. C#启动wind ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0xEjp.html" rel="bookmark" class="title">JQuery之proxy实现绑定代理方法&lowbar;jquery</a>
					<div>
						在javascript中,this指代的对象时常会变化,这会造成程序,混乱,一般做法就是先将this保存在一个变量中,就不怕她变了,我们先看一个小例子 var A = function(){ this ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1v4Qb.html" rel="bookmark" class="title">asp&period;net分割字符串的几种方法小结&lowbar;实用技巧</a>
					<div>
						下面一一介绍一下: 1.最简单最常用的方法,以一个指定的字符进行的分割 打开vs.net新建一个控制台项目.然后在Main()方法下输入下面的程序. 复制代码 代码如下: string s=&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/MgExemz.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vaW1hZ2UyMC5pdDE2OC5jb20vMjAxNDA3XzUwMHgzNzUvMTkxNi9jZTBmZmQ4ZjMwM2M2ZTA1LnBuZw==.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/MgExemz.html" rel="bookmark" class="title">不同角度看世界：十大数据可视化站点</a>
					<div>
						一.全球黑客活动 从黑客活动开始踏上可视化数据工具体验之旅.这份迷人的地图由安全供应商Norse打造,其本质是一套反映全球范围内黑客攻击频率的快照.它利用Norse的&quot;蜜罐&quot;攻击陷 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Q974M.html" rel="bookmark" class="title">c语言-怎样用sscanf取数据？？？</a>
					<div>
						问题描述 怎样用sscanf取数据??? sscanf(str,&quot;(%f)%c(%f)&quot;,&amp;data1,&amp;f,&amp;data2);这样只能取出括号里的数,如(- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Y2xNp.html" rel="bookmark" class="title">《百度服务器硬盘损坏》后续</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 继上次vermin访问百度总部,报道百度服务器硬盘损坏事件后至今,已历时二月之久. 原本对于百度这样的大型数据存储公司而言,损坏些磁盘本是很普通的事件, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdv0rxb.html" rel="bookmark" class="title">特朗普推翻美国ISP隐私政策 允许电信运营商销售用户数据</a>
					<div>
						本周一,美国总统唐纳德·特朗普(Donald Trump)签署了一份决议,废除了FCC针对互联网服务提供商(ISP)提出的隐私规则,正式推翻了奥巴马政府时代制定的隐私政策. FCC在去年8月实施了这一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjoYvZM.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;积分宝贝&rdquo;，&OpenCurlyDoubleQuote;积分宝&rdquo;，两者是否属于近似商标</a>
					<div>
						近日,市一中院作出终审判决,认定两者不属于近似商标,&quot;积分宝贝&quot;商标所有者钥尊公司的停止侵权.消除影响.赔偿损失等诉请均未获支持. 钥尊公司是成立于2006年10月的一家贸易公司. ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.025 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
